Index: issm/trunk/src/c/classes/kriging/Quadtree.cpp
===================================================================
--- issm/trunk/src/c/classes/kriging/Quadtree.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/Quadtree.cpp	(revision 18301)
@@ -81,12 +81,10 @@
 
 	/*Constructors/Destructors*/
-/*FUNCTION Quadtree::Quadtree(){{{*/
-Quadtree::Quadtree(){
+Quadtree::Quadtree(){/*{{{*/
 	_error_("Constructor not supported");
 
 }
 /*}}}*/
-/*FUNCTION Quadtree::Quadtree(double xmin,double xmax,double ymin,double ymax,int maxdepth){{{*/
-Quadtree::Quadtree(double xmin,double xmax,double ymin,double ymax,int maxdepth){
+Quadtree::Quadtree(double xmin,double xmax,double ymin,double ymax,int maxdepth){/*{{{*/
 
 	/*Intermediaries*/
@@ -106,6 +104,5 @@
 }
 /*}}}*/
-	/*FUNCTION Quadtree::~Quadtree(){{{*/
-	Quadtree::~Quadtree(){
+	Quadtree::~Quadtree(){/*{{{*/
 
 		delete boxcontainer;
@@ -116,6 +113,5 @@
 
 	/*Methods*/
-/*FUNCTION Quadtree::Add{{{*/
-void  Quadtree::Add(Observation* observation){
+void  Quadtree::Add(Observation* observation){/*{{{*/
 
 	/*Intermediaries*/
@@ -199,6 +195,5 @@
 
 }/*}}}*/
-/*FUNCTION Quadtree::AddAndAverage{{{*/
-void Quadtree::AddAndAverage(double x,double y,double value){
+void Quadtree::AddAndAverage(double x,double y,double value){/*{{{*/
 
 	QuadtreeBox **pbox = NULL;
@@ -248,6 +243,5 @@
 	}
 }/*}}}*/
-/*FUNCTION Quadtree::ClosestObs{{{*/
-void Quadtree::ClosestObs(int *pindex,double x,double y){
+void Quadtree::ClosestObs(int *pindex,double x,double y){/*{{{*/
 
 	QuadtreeBox **pbox = NULL;
@@ -288,6 +282,5 @@
 	*pindex=index;
 }/*}}}*/
-/*FUNCTION Quadtree::Echo{{{*/
-void  Quadtree::Echo(void){
+void  Quadtree::Echo(void){/*{{{*/
 
 	_printf_("Quadtree:\n");
@@ -298,6 +291,5 @@
 
 }/*}}}*/
-/*FUNCTION Quadtree::DeepEcho{{{*/
-void  Quadtree::DeepEcho(void){
+void  Quadtree::DeepEcho(void){/*{{{*/
 
 	_printf_("Quadtree:\n");
@@ -309,6 +301,5 @@
 
 }/*}}}*/
-/*FUNCTION Quadtree::IntergerCoordinates{{{*/
-void  Quadtree::IntergerCoordinates(int *xi,int *yi,double x,double y){
+void  Quadtree::IntergerCoordinates(int *xi,int *yi,double x,double y){/*{{{*/
 
 	/*Intermediaries*/
@@ -333,6 +324,5 @@
 	*yi=int(coefficient*(y - ymin));
 }/*}}}*/
-/*FUNCTION Quadtree::NewQuadtreeBox(double xcenter,double ycenter,double length){{{*/
-Quadtree::QuadtreeBox* Quadtree::NewQuadtreeBox(double xcenter,double ycenter,double length){
+Quadtree::QuadtreeBox* Quadtree::NewQuadtreeBox(double xcenter,double ycenter,double length){/*{{{*/
 
 	/*Output*/
@@ -357,6 +347,5 @@
 	return newbox;
 }/*}}}*/
-/*FUNCTION Quadtree::NewQuadtreeBox(QuadtreeBox* master,int index) {{{*/
-Quadtree::QuadtreeBox* Quadtree::NewQuadtreeBox(QuadtreeBox* master,int index){
+Quadtree::QuadtreeBox* Quadtree::NewQuadtreeBox(QuadtreeBox* master,int index){/*{{{*/
 
 	/*Output*/
@@ -402,6 +391,5 @@
 	return newbox;
 }/*}}}*/
-/*FUNCTION Quadtree::QuadtreeDepth{{{*/
-void Quadtree::QuadtreeDepth(int* A,int xi,int yi){
+void Quadtree::QuadtreeDepth(int* A,int xi,int yi){/*{{{*/
 
 	QuadtreeBox **pbox = NULL;
@@ -430,6 +418,5 @@
 	*A=level;
 }/*}}}*/
-/*FUNCTION Quadtree::QuadtreeDepth2{{{*/
-void Quadtree::QuadtreeDepth2(int* A,int xi,int yi){
+void Quadtree::QuadtreeDepth2(int* A,int xi,int yi){/*{{{*/
 
 	QuadtreeBox **pbox = NULL;
@@ -483,6 +470,5 @@
 	*A=level;
 }/*}}}*/
-/*FUNCTION Quadtree::RangeSearch{{{*/
-void Quadtree::RangeSearch(int **pindices,int *pnobs,double x,double y,double range){
+void Quadtree::RangeSearch(int **pindices,int *pnobs,double x,double y,double range){/*{{{*/
 
 	/*Intermediaries*/
@@ -503,6 +489,5 @@
 
 /*QuadtreeBox methos*/
-/*FUNCTION QuadtreeBox::Echo{{{*/
-void  Quadtree::QuadtreeBox::Echo(void){
+void  Quadtree::QuadtreeBox::Echo(void){/*{{{*/
 
 	_printf_("QuadtreeBox:\n");
@@ -513,6 +498,25 @@
 
 }/*}}}*/
-/*FUNCTION QuadtreeBox::IsWithinRange{{{*/
-int Quadtree::QuadtreeBox::IsWithinRange(double x,double y,double range){
+Object* Quadtree::QuadtreeBox::copy(void){/*{{{*/
+
+	   QuadtreeBox* qtreebox = new QuadtreeBox(*this);
+
+		if (this->box){	
+			for (int i=0; i<4; ++i){
+				if(this->box[i]) qtreebox->box[i] = reinterpret_cast<QuadtreeBox*>(this->box[i]->copy());
+				else qtreebox->box[i] = NULL;
+			}
+		}
+		if (this->obs){
+			for (int i=0; i<4; ++i){
+				if(this->obs[i]) qtreebox->obs[i] = reinterpret_cast<Observation*>(this->obs[i]->copy());
+				else qtreebox->obs[i] = NULL;
+			}
+		}
+
+		return (Object*) qtreebox;
+}
+/*}}}*/
+int Quadtree::QuadtreeBox::IsWithinRange(double x,double y,double range){/*{{{*/
 
 	/*Return 0 if the 2 boxes do not overlap*/
@@ -532,6 +536,5 @@
 
 }/*}}}*/
-/*FUNCTION QuadtreeBox::RangeSearch{{{*/
-void Quadtree::QuadtreeBox::RangeSearch(int* indices,int *pnobs,double x,double y,double range){
+void Quadtree::QuadtreeBox::RangeSearch(int* indices,int *pnobs,double x,double y,double range){/*{{{*/
 
 	/*Intermediaries*/
@@ -574,6 +577,5 @@
 	*pnobs=nobs;
 }/*}}}*/
-/*FUNCTION QuadtreeBox::WriteObservations{{{*/
-void Quadtree::QuadtreeBox::WriteObservations(int* indices,int *pnobs){
+void Quadtree::QuadtreeBox::WriteObservations(int* indices,int *pnobs){/*{{{*/
 
 	/*Intermediaries*/
Index: issm/trunk/src/c/classes/kriging/Quadtree.h
===================================================================
--- issm/trunk/src/c/classes/kriging/Quadtree.h	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/Quadtree.h	(revision 18301)
@@ -30,5 +30,5 @@
 				int     Id()        {_error_("not implemented yet"); };
 				int     ObjectEnum(){_error_("not implemented yet"); };
-				Object *copy()      {_error_("not implemented yet"); };
+				Object *copy();
 
 				/*Methods*/
Index: issm/trunk/src/c/classes/kriging/SphericalVariogram.cpp
===================================================================
--- issm/trunk/src/c/classes/kriging/SphericalVariogram.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/SphericalVariogram.cpp	(revision 18301)
@@ -13,6 +13,5 @@
 
 /*SphericalVariogram constructors and destructor*/
-/*FUNCTION SphericalVariogram::SphericalVariogram(){{{*/
-SphericalVariogram::SphericalVariogram(){
+SphericalVariogram::SphericalVariogram(){/*{{{*/
 	this->nugget = 0.2;
 	this->sill   = 1;
@@ -21,6 +20,5 @@
 }
 /*}}}*/
-/*FUNCTION SphericalVariogram::SphericalVariogram(Options* options){{{*/
-SphericalVariogram::SphericalVariogram(Options* options){
+SphericalVariogram::SphericalVariogram(Options* options){/*{{{*/
 
 	/*Defaults*/
@@ -38,6 +36,5 @@
 }
 /*}}}*/
-/*FUNCTION SphericalVariogram::~SphericalVariogram(){{{*/
-SphericalVariogram::~SphericalVariogram(){
+SphericalVariogram::~SphericalVariogram(){/*{{{*/
 	return;
 }
@@ -45,6 +42,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION SphericalVariogram::Echo {{{*/
-void SphericalVariogram::Echo(void){
+void SphericalVariogram::Echo(void){/*{{{*/
 	_printf_("SphericalVariogram\n");
 	_printf_("   nugget: " << this->nugget << "\n");
@@ -53,8 +49,11 @@
 }
 /*}}}*/
+Object* SphericalVariogram::copy(void){/*{{{*/
+	return new SphericalVariogram(*this);
+}
+/*}}}*/
 
 /*Variogram function*/
-/*FUNCTION SphericalVariogram::Covariance{{{*/
-double SphericalVariogram::Covariance(double deltax,double deltay){
+double SphericalVariogram::Covariance(double deltax,double deltay){/*{{{*/
 	/*The covariance can be deduced from the variogram from the following
 	 * relationship:
@@ -76,6 +75,5 @@
 }
 /*}}}*/
-/*FUNCTION SphericalVariogram::SemiVariogram{{{*/
-double SphericalVariogram::SemiVariogram(double deltax,double deltay){
+double SphericalVariogram::SemiVariogram(double deltax,double deltay){/*{{{*/
 	/*http://en.wikipedia.org/wiki/Variogram*/
 	double h,gamma;
Index: issm/trunk/src/c/classes/kriging/SphericalVariogram.h
===================================================================
--- issm/trunk/src/c/classes/kriging/SphericalVariogram.h	(revision 18081)
+++ issm/trunk/src/c/classes/kriging/SphericalVariogram.h	(revision 18301)
@@ -26,5 +26,5 @@
 		int   Id(){_error_("Not implemented yet");}; 
 		int   ObjectEnum(){_error_("Not implemented yet");};
-		Object* copy(){_error_("Not implemented yet");};
+		Object* copy();
 
 		/*Variogram functions*/
Index: issm/trunk/src/c/classes/matrix/ElementMatrix.cpp
===================================================================
--- issm/trunk/src/c/classes/matrix/ElementMatrix.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/matrix/ElementMatrix.cpp	(revision 18301)
@@ -18,6 +18,5 @@
 
 /*ElementMatrix constructors and destructor*/
-/*FUNCTION ElementMatrix::ElementMatrix(){{{*/
-ElementMatrix::ElementMatrix(){
+ElementMatrix::ElementMatrix(){/*{{{*/
 
 	this->nrows=0;
@@ -42,6 +41,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementMatrix::ElementMatrix(ElementMatrix* Ke){{{*/
-ElementMatrix::ElementMatrix(ElementMatrix* Ke){
+ElementMatrix::ElementMatrix(ElementMatrix* Ke){/*{{{*/
 
 	if(!Ke) _error_("Input Element Matrix is a NULL pointer");
@@ -50,6 +48,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementMatrix::ElementMatrix(ElementMatrix* Ke1, ElementMatrix* Ke2){{{*/
-ElementMatrix::ElementMatrix(ElementMatrix* Ke1, ElementMatrix* Ke2){
+ElementMatrix::ElementMatrix(ElementMatrix* Ke1, ElementMatrix* Ke2){/*{{{*/
 
 	/*intermediaries*/
@@ -179,6 +176,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementMatrix::ElementMatrix(ElementMatrix* Ke1, ElementMatrix* Ke2,ElementMatrix* Ke3){{{*/
-ElementMatrix::ElementMatrix(ElementMatrix* Ke1, ElementMatrix* Ke2,ElementMatrix* Ke3){
+ElementMatrix::ElementMatrix(ElementMatrix* Ke1, ElementMatrix* Ke2,ElementMatrix* Ke3){/*{{{*/
 
 	/*Concatenate all matrices*/
@@ -194,6 +190,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementMatrix::ElementMatrix(Node** nodes,int numnodes,Parameters* parameters,int approximation){{{*/
-ElementMatrix::ElementMatrix(Node** nodes,int numnodes,Parameters* parameters,int approximation){
+ElementMatrix::ElementMatrix(Node** nodes,int numnodes,Parameters* parameters,int approximation){/*{{{*/
 
 	/*get Matrix size and properties*/
@@ -225,6 +220,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementMatrix::~ElementMatrix(){{{*/
-ElementMatrix::~ElementMatrix(){
+ElementMatrix::~ElementMatrix(){/*{{{*/
 
 	xDelete<IssmDouble>(this->values);
@@ -242,6 +236,5 @@
 
 /*ElementMatrix specific routines: */
-/*FUNCTION ElementMatrix::AddToGlobal(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){{{*/
-void ElementMatrix::AddToGlobal(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){
+void ElementMatrix::AddToGlobal(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){/*{{{*/
 
 	int i,j;
@@ -300,6 +293,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementMatrix::AddToGlobal(Matrix<IssmDouble>* Jff){{{*/
-void ElementMatrix::AddToGlobal(Matrix<IssmDouble>* Jff){
+void ElementMatrix::AddToGlobal(Matrix<IssmDouble>* Jff){/*{{{*/
 
 	int i,j;
@@ -337,6 +329,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementMatrix::CheckConsistency{{{*/
-void ElementMatrix::CheckConsistency(void){
+void ElementMatrix::CheckConsistency(void){/*{{{*/
 	/*Check element matrix values, only in debugging mode*/
 	#ifdef _ISSM_DEBUG_ 
@@ -350,6 +341,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementMatrix::Transpose{{{*/
-void ElementMatrix::Transpose(void){
+void ElementMatrix::Transpose(void){/*{{{*/
 
 	/*Intermediaries*/
@@ -373,6 +363,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementMatrix::StaticCondensation{{{*/
-void ElementMatrix::StaticCondensation(int bsize,int* bindices){
+void ElementMatrix::StaticCondensation(int bsize,int* bindices){/*{{{*/
 	/* 
 	 * | Kii  Kib | | Ui |    |Fi|
@@ -477,6 +466,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementMatrix::Echo{{{*/
-void ElementMatrix::Echo(void){
+void ElementMatrix::Echo(void){/*{{{*/
 
 	int i,j;
@@ -523,6 +511,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementMatrix::Init{{{*/
-void ElementMatrix::Init(ElementMatrix* Ke){
+void ElementMatrix::Init(ElementMatrix* Ke){/*{{{*/
 
 	_assert_(Ke);
Index: issm/trunk/src/c/classes/matrix/ElementVector.cpp
===================================================================
--- issm/trunk/src/c/classes/matrix/ElementVector.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/matrix/ElementVector.cpp	(revision 18301)
@@ -18,6 +18,5 @@
 
 /*ElementVector constructors and destructor*/
-/*FUNCTION ElementVector::ElementVector(){{{*/
-ElementVector::ElementVector(){
+ElementVector::ElementVector(){/*{{{*/
 
 	this->nrows=0;
@@ -29,6 +28,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementVector::ElementVector(ElementVector* pe1, ElementVector* pe2){{{*/
-ElementVector::ElementVector(ElementVector* pe1, ElementVector* pe2){
+ElementVector::ElementVector(ElementVector* pe1, ElementVector* pe2){/*{{{*/
 
 	/*intermediaries*/
@@ -114,6 +112,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementVector::ElementVector(ElementVector* pe1, ElementVector* pe2,ElementVector* pe3){{{*/
-ElementVector::ElementVector(ElementVector* pe1, ElementVector* pe2,ElementVector* pe3){
+ElementVector::ElementVector(ElementVector* pe1, ElementVector* pe2,ElementVector* pe3){/*{{{*/
 
 	/*Concatenate all matrices*/
@@ -129,6 +126,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementVector::ElementVector(Node** nodes,int numnodes,Parameters* parameters,int approximation){{{*/
-ElementVector::ElementVector(Node** nodes,int numnodes,Parameters* parameters,int approximation){
+ElementVector::ElementVector(Node** nodes,int numnodes,Parameters* parameters,int approximation){/*{{{*/
 
 	/*get Vector size and properties*/
@@ -147,6 +143,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementVector::~ElementVector(){{{*/
-ElementVector::~ElementVector(){
+ElementVector::~ElementVector(){/*{{{*/
 
 	xDelete<IssmDouble>(this->values);
@@ -158,6 +153,5 @@
 
 /*ElementVector specific routines: */
-/*FUNCTION ElementVector::AddToGlobal(Vector<IssmDouble>* pf){{{*/
-void ElementVector::AddToGlobal(Vector<IssmDouble>* pf){
+void ElementVector::AddToGlobal(Vector<IssmDouble>* pf){/*{{{*/
 
 	int i;
@@ -182,6 +176,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementVector::InsertIntoGlobal(Vector<IssmDouble>* pf){{{*/
-void ElementVector::InsertIntoGlobal(Vector<IssmDouble>* pf){
+void ElementVector::InsertIntoGlobal(Vector<IssmDouble>* pf){/*{{{*/
 
 	int i;
@@ -203,6 +196,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementVector::CheckConsistency{{{*/
-void ElementVector::CheckConsistency(void){
+void ElementVector::CheckConsistency(void){/*{{{*/
 	/*Check element matrix values, only in debugging mode*/
 #ifdef _ISSM_DEBUG_ 
@@ -214,6 +206,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementVector::Echo{{{*/
-void ElementVector::Echo(void){
+void ElementVector::Echo(void){/*{{{*/
 
 	int i;
@@ -239,6 +230,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementVector::Init{{{*/
-void ElementVector::Init(ElementVector* pe){
+void ElementVector::Init(ElementVector* pe){/*{{{*/
 
 	_assert_(pe);
@@ -265,6 +255,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementVector::SetValue{{{*/
-void ElementVector::SetValue(IssmDouble scalar){
+void ElementVector::SetValue(IssmDouble scalar){/*{{{*/
 
 	int i;
@@ -274,6 +263,5 @@
 }
 /*}}}*/
-/*FUNCTION ElementVector::StaticCondensation{{{*/
-void ElementVector::StaticCondensation(ElementMatrix* Ke,int bsize,int* bindices){
+void ElementVector::StaticCondensation(ElementMatrix* Ke,int bsize,int* bindices){/*{{{*/
 	/* 
 	 * | Kii  Kib | | Ui |    |Fi|
Index: issm/trunk/src/c/cores/AnalysisConfiguration.cpp
===================================================================
--- issm/trunk/src/c/cores/AnalysisConfiguration.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/AnalysisConfiguration.cpp	(revision 18301)
@@ -26,5 +26,5 @@
 
 		case StressbalanceSolutionEnum:
-			numanalyses=6;
+			numanalyses=7;
 			analyses=xNew<int>(numanalyses);
 			analyses[0]=StressbalanceAnalysisEnum;
@@ -34,4 +34,5 @@
 			analyses[4]=ExtrudeFromBaseAnalysisEnum;
 			analyses[5]=DepthAverageAnalysisEnum;
+			analyses[6]=UzawaPressureAnalysisEnum;
 			break;
 
Index: issm/trunk/src/c/cores/DakotaSpawnCore.cpp
===================================================================
--- issm/trunk/src/c/cores/DakotaSpawnCore.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/DakotaSpawnCore.cpp	(revision 18301)
@@ -51,6 +51,7 @@
 	if(counter==-1)return 0;
 
-	/*cast void_femmodel to FemModel: */
-	femmodel=reinterpret_cast<FemModel*>(void_femmodel);
+	/*cast void_femmodel to FemModel, and at the same time, make a copy, so we start this new core run for this specific sample 
+	 *with a brand new copy of the model, which has not been tempered with by previous dakota runs: */
+	femmodel=(reinterpret_cast<FemModel*>(void_femmodel))->copy();
 
 	/*retrieve parameters: */
@@ -80,4 +81,7 @@
 	/*Free ressources:*/
 	DakotaFree(&d_variables,&d_variables_descriptors,&responses_descriptors, d_numvariables, numresponsedescriptors);
+
+	/*Avoid leaks here: */
+	delete femmodel;
 
 	return 1; //this is critical! do not return 0, otherwise, dakota_core will stop running!
Index: issm/trunk/src/c/cores/WrapperCorePointerFromSolutionEnum.cpp
===================================================================
--- issm/trunk/src/c/cores/WrapperCorePointerFromSolutionEnum.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/WrapperCorePointerFromSolutionEnum.cpp	(revision 18301)
@@ -46,4 +46,5 @@
 			case 1: solutioncore=controltao_core; break;
 			case 2: solutioncore=controlm1qn3_core; break;
+			case 3: solutioncore=controlvalidation_core; break;
 			default: _error_("control type not supported");
 		}
Index: issm/trunk/src/c/cores/adjointbalancethickness2_core.cpp
===================================================================
--- issm/trunk/src/c/cores/adjointbalancethickness2_core.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/adjointbalancethickness2_core.cpp	(revision 18301)
@@ -32,5 +32,5 @@
 
 	/*Save results*/
-	if(save_results){
+	if(save_results || true){
 		if(VerboseSolution()) _printf0_("   saving results\n");
 		int outputs[1] = {AdjointEnum};
Index: issm/trunk/src/c/cores/control_core.cpp
===================================================================
--- issm/trunk/src/c/cores/control_core.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/control_core.cpp	(revision 18301)
@@ -11,33 +11,27 @@
 
 /*Local prototypes*/
-bool controlconvergence(IssmDouble J, IssmDouble tol_cm);
-IssmDouble objectivefunction(IssmDouble search_scalar,void* optargs);
-
-void control_core(FemModel* femmodel){
-
-	int     i;
+/*{{{*/
+IssmDouble FormFunction(IssmDouble* X,void* usr);
+IssmDouble FormFunctionGradient(IssmDouble** pG,IssmDouble* X,void* usr);
+typedef struct {
+	FemModel* femmodel;
+	int       nsize;
+} AppCtx;
+/*}}}*/
+
+void control_core(FemModel* femmodel){/*{{{*/
 
 	/*parameters: */
-	int        num_controls;
-	int        nsteps;
-	IssmDouble tol_cm;
-	int        solution_type;
-	bool       isFS;
-	bool       dakota_analysis = false;
-
-	int        *control_type   = NULL;
-	IssmDouble *maxiter        = NULL;
-	IssmDouble *cm_jump        = NULL;
-
-	/*intermediary: */
-	IssmDouble search_scalar = 1.;
-	OptPars    optpars;
+	int         num_controls,nsize,nsteps;
+	int         solution_type;
+	bool        isFS,dakota_analysis;
+	int        *control_type  = NULL;
+	int        *maxiter       = NULL;
+	IssmDouble *cm_jump       = NULL;
+	IssmDouble *J             = NULL;
 
 	/*Solution and Adjoint core pointer*/
 	void (*solutioncore)(FemModel*) = NULL;
 	void (*adjointcore)(FemModel*)  = NULL;
-
-	/*output: */
-	IssmDouble* J=NULL;
 
 	/*Recover parameters used throughout the solution*/
@@ -47,5 +41,4 @@
 	femmodel->parameters->FindParam(&maxiter,NULL,InversionMaxiterPerStepEnum);
 	femmodel->parameters->FindParam(&cm_jump,NULL,InversionStepThresholdEnum);
-	femmodel->parameters->FindParam(&tol_cm,InversionCostFunctionThresholdEnum);
 	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
 	femmodel->parameters->FindParam(&isFS,FlowequationIsFSEnum);
@@ -61,35 +54,40 @@
 	if(isFS) solutioncore(femmodel);
 
-	/*Initialize cost function: */
-	J=xNew<IssmDouble>(nsteps);
+	/*Get initial guess*/
+	Vector<IssmDouble> *Xpetsc = NULL;
+	GetVectorFromControlInputsx(&Xpetsc,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"value");
+	IssmDouble* X0 = Xpetsc->ToMPISerial();
+	Xpetsc->GetSize(&nsize);
+	delete Xpetsc;
 
 	/*Initialize some of the BrentSearch arguments: */
-	optpars.xmin=0; optpars.xmax=1;
-
-	/*Start looping: */
-	for(int n=0;n<nsteps;n++){
-
-		/*Display info*/
-		if(VerboseControl()) _printf0_("\n" << "   control method step " << n+1 << "/" << nsteps << "\n");
-
-
-		/*In steady state inversion, compute new temperature field now*/
-		if(solution_type==SteadystateSolutionEnum) solutioncore(femmodel);
-
-		if(VerboseControl()) _printf0_("   compute adjoint state:\n");
-		adjointcore(femmodel);
-		gradient_core(femmodel,n,search_scalar==0.);
-
-		if(VerboseControl()) _printf0_("   optimizing along gradient direction\n");
-		optpars.maxiter=reCast<int,IssmDouble>(maxiter[n]); optpars.cm_jump=cm_jump[n];
-		BrentSearch(&search_scalar,J+n,&optpars,&objectivefunction,(void*)femmodel);
-
-		if(VerboseControl()) _printf0_("   updating parameter using optimized search scalar\n"); //true means update save controls
-		InputControlUpdatex(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,search_scalar,true);
-
-		if(controlconvergence(J[n],tol_cm)) break;
-	}
+	OptPars optpars;
+	optpars.xmin    = 0; 
+	optpars.xmax    = 1;
+	optpars.nsteps  = nsteps;
+	optpars.nsize   = nsize;
+	optpars.maxiter = maxiter;
+	optpars.cm_jump = cm_jump;
+
+	/*Initialize function argument*/
+	AppCtx usr;
+	usr.femmodel = femmodel;
+	usr.nsize    = nsize;
+
+	/*Call Brent optimization*/
+	BrentSearch(&J,optpars,X0,&FormFunction,&FormFunctionGradient,(void*)&usr);
 
 	if(VerboseControl()) _printf0_("   preparing final solution\n");
+	IssmDouble  *XL = NULL;
+	IssmDouble  *XU = NULL;
+	GetVectorFromControlInputsx(&XL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
+	GetVectorFromControlInputsx(&XU,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
+	for(long i=0;i<nsize;i++){
+		if(X0[i]>XU[i]) X0[i]=XU[i];
+		if(X0[i]<XL[i]) X0[i]=XL[i];
+	}
+	xDelete<IssmDouble>(XU);
+	xDelete<IssmDouble>(XL);
+	SetControlInputsFromVectorx(femmodel,X0);
 	femmodel->parameters->SetParam(true,SaveResultsEnum);
 	solutioncore(femmodel);
@@ -101,5 +99,5 @@
 		#ifdef _HAVE_ADOLC_
 		IssmPDouble* J_passive=xNew<IssmPDouble>(nsteps);
-		for(i=0;i<nsteps;i++) J_passive[i]=reCast<IssmPDouble>(J[i]);
+		for(int i=0;i<nsteps;i++) J_passive[i]=reCast<IssmPDouble>(J[i]);
 		femmodel->results->AddObject(new GenericExternalResult<IssmPDouble*>(femmodel->results->Size()+1,JEnum,J_passive,nsteps,1,1,0));
 		xDelete<IssmPDouble>(J_passive);
@@ -111,22 +109,10 @@
 	/*Free ressources: */
 	xDelete<int>(control_type);
-	xDelete<IssmDouble>(maxiter);
+	xDelete<int>(maxiter);
 	xDelete<IssmDouble>(cm_jump);
 	xDelete<IssmDouble>(J);
-}
-bool controlconvergence(IssmDouble J, IssmDouble tol_cm){
-
-	bool converged=false;
-
-	/*Has convergence been reached?*/
-	if (!xIsNan<IssmDouble>(tol_cm) && J<tol_cm){
-		converged=true;
-		if(VerboseConvergence()) _printf0_("      Convergence criterion reached: J = " << J << " < " << tol_cm);
-	}
-
-	return converged;
-}
-
-IssmDouble objectivefunction(IssmDouble search_scalar,void* optargs){
+	xDelete<IssmDouble>(X0);
+}/*}}}*/
+IssmDouble FormFunction(IssmDouble* X,void* usrvoid){/*{{{*/
 
 	/*output: */
@@ -134,52 +120,146 @@
 
 	/*parameters: */
-	int        solution_type,analysis_type;
-	bool       isFS       = false;
+	int        solution_type,analysis_type,num_responses;
 	bool       conserve_loads = true;
-	FemModel  *femmodel       = (FemModel*)optargs;
+	AppCtx*    usr = (AppCtx*)usrvoid;
+	FemModel  *femmodel  = usr->femmodel;
+	int        nsize     = usr->nsize;
 
 	/*Recover parameters: */
-	femmodel->parameters->FindParam(&isFS,FlowequationIsFSEnum);
 	femmodel->parameters->FindParam(&analysis_type,AnalysisTypeEnum);
 	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
-
-	/*set analysis type to compute velocity: */
-	if (solution_type==SteadystateSolutionEnum || solution_type==StressbalanceSolutionEnum){
-		femmodel->SetCurrentConfiguration(StressbalanceAnalysisEnum);
-	}
-	else if (solution_type==BalancethicknessSolutionEnum){
-		femmodel->SetCurrentConfiguration(BalancethicknessAnalysisEnum);
-	}
-	else if (solution_type==BalancethicknessSoftSolutionEnum){
-		femmodel->SetCurrentConfiguration(BalancethicknessAnalysisEnum);
-	}
-	else{
-		_error_("Solution " << EnumToStringx(solution_type) << " not implemented yet");
-	}
-
-	/*update parameter according to scalar: */ //false means: do not save control
-	InputControlUpdatex(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,search_scalar,false);
-
-	/*Run stressbalance with updated inputs: */
-	if (solution_type==SteadystateSolutionEnum){
-		stressbalance_core(femmodel);	//We need a 3D velocity!! (vz is required for the next thermal run)
-	}
-	else if (solution_type==StressbalanceSolutionEnum){
-		solutionsequence_nonlinear(femmodel,conserve_loads); 
-	}
-	else if (solution_type==BalancethicknessSolutionEnum){
-		solutionsequence_linear(femmodel); 
-	}
-	else if (solution_type==BalancethicknessSoftSolutionEnum){
-		/*Don't do anything*/
-	}
-	else{
-		_error_("Solution " << EnumToStringx(solution_type) << " not implemented yet");
+	femmodel->parameters->FindParam(&num_responses,InversionNumCostFunctionsEnum);
+
+	/*Constrain input vector*/
+	IssmDouble  *XL = NULL;
+	IssmDouble  *XU = NULL;
+	GetVectorFromControlInputsx(&XL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
+	GetVectorFromControlInputsx(&XU,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
+	for(long i=0;i<nsize;i++){
+		if(X[i]>XU[i]) X[i]=XU[i];
+		if(X[i]<XL[i]) X[i]=XL[i];
+	}
+
+	/*Update control input*/
+	SetControlInputsFromVectorx(femmodel,X);
+
+	/*solve forward: */
+	switch(solution_type){
+		case SteadystateSolutionEnum:
+			femmodel->SetCurrentConfiguration(StressbalanceAnalysisEnum);
+			stressbalance_core(femmodel);	//We need a 3D velocity!! (vz is required for the next thermal run)
+			break;
+		case StressbalanceSolutionEnum:
+			femmodel->SetCurrentConfiguration(StressbalanceAnalysisEnum);
+			solutionsequence_nonlinear(femmodel,conserve_loads); 
+			break;
+		case BalancethicknessSolutionEnum:
+			femmodel->SetCurrentConfiguration(BalancethicknessAnalysisEnum);
+			solutionsequence_linear(femmodel); 
+			break;
+		case BalancethicknessSoftSolutionEnum:
+			/*NOTHING*/
+			break;
+		case Balancethickness2SolutionEnum:
+			femmodel->SetCurrentConfiguration(Balancethickness2AnalysisEnum);
+			solutionsequence_linear(femmodel); 
+			break;
+		default:
+			_error_("Solution " << EnumToStringx(solution_type) << " not implemented yet");
 	}
 
 	/*Compute misfit for this velocity field.*/
-	femmodel->CostFunctionx(&J,NULL,NULL);
+	IssmDouble* Jlist = NULL;
+	femmodel->CostFunctionx(&J,&Jlist,NULL);
+	_printf0_("f(x) = "<<setw(12)<<setprecision(7)<<J<<"  |  ");
+	for(int i=0;i<num_responses;i++) _printf0_(" "<<setw(12)<<setprecision(7)<<Jlist[i]);
+	_printf0_("\n");
 
 	/*Free ressources:*/
+	xDelete<IssmDouble>(XU);
+	xDelete<IssmDouble>(XL);
+	xDelete<IssmDouble>(Jlist);
 	return J;
-}
+}/*}}}*/
+IssmDouble FormFunctionGradient(IssmDouble** pG,IssmDouble* X,void* usrvoid){/*{{{*/
+
+	/*output: */
+	IssmDouble J;
+
+	/*parameters: */
+	void (*adjointcore)(FemModel*)=NULL;
+	int         solution_type,analysis_type,num_responses,num_controls,numvertices;
+	bool        conserve_loads = true;
+	IssmDouble *scalar_list    = NULL;
+	IssmDouble *Jlist          = NULL;
+	IssmDouble *G              = NULL;
+	IssmDouble *norm_list      = NULL;
+	AppCtx     *usr            = (AppCtx*)usrvoid;
+	FemModel   *femmodel       = usr->femmodel;
+	int         nsize          = usr->nsize;
+
+	/*Recover parameters: */
+	femmodel->parameters->FindParam(&analysis_type,AnalysisTypeEnum);
+	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
+	femmodel->parameters->FindParam(&num_responses,InversionNumCostFunctionsEnum);
+	femmodel->parameters->FindParam(&scalar_list,NULL,NULL,InversionGradientScalingEnum);
+	femmodel->parameters->FindParam(&num_controls,InversionNumControlParametersEnum);   _assert_(num_controls);
+	numvertices=femmodel->vertices->NumberOfVertices();
+
+	/*Constrain input vector*/
+	IssmDouble  *XL = NULL;
+	IssmDouble  *XU = NULL;
+	GetVectorFromControlInputsx(&XL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"lowerbound");
+	GetVectorFromControlInputsx(&XU,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"upperbound");
+	for(long i=0;i<nsize;i++){
+		if(X[i]>XU[i]) X[i]=XU[i];
+		if(X[i]<XL[i]) X[i]=XL[i];
+	}
+
+	/*Update control input*/
+	SetControlInputsFromVectorx(femmodel,X);
+
+	/*Compute new temperature at this point*/
+	if(solution_type==SteadystateSolutionEnum) steadystate_core(femmodel);
+
+	/*Compute Adjoint*/
+	AdjointCorePointerFromSolutionEnum(&adjointcore,solution_type);
+	adjointcore(femmodel);
+
+	/*Compute gradient*/
+	Gradjx(&G,&norm_list,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+
+	/*Compute scaling factor*/
+	IssmDouble scalar = scalar_list[0]/norm_list[0];
+	for(int i=1;i<num_controls;i++) scalar=min(scalar,scalar_list[i]/norm_list[i]);
+
+	/*Constrain Gradient*/
+	for(int i=0;i<num_controls;i++){
+		for(int j=0;j<numvertices;j++){
+			G[i*numvertices+j] = scalar*G[i*numvertices+j];
+		}
+	}
+
+	for(long i=0;i<nsize;i++){
+		if(X[i]>=XU[i]) G[i]=0.;
+		if(X[i]<=XL[i]) G[i]=0.;
+	}
+
+	/*Needed for output results*/
+	ControlInputSetGradientx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,G);
+
+	/*Compute misfit for this velocity field.*/
+	femmodel->CostFunctionx(&J,&Jlist,NULL);
+	_printf0_("f(x) = "<<setw(12)<<setprecision(7)<<J<<"  |  ");
+	for(int i=0;i<num_responses;i++) _printf0_(" "<<setw(12)<<setprecision(7)<<Jlist[i]);
+	_printf0_("\n");
+
+	/*Clean-up and return*/
+	xDelete<IssmDouble>(XU);
+	xDelete<IssmDouble>(XL);
+	xDelete<IssmDouble>(norm_list);
+	xDelete<IssmDouble>(scalar_list);
+	xDelete<IssmDouble>(Jlist);
+	*pG = G;
+	return J;
+}/*}}}*/
